#!/bin/bash
# vim  :set tabstop=4
# NeoKylin Linux Server 7.0
###########################################
#        post-install-for-mips64el        #
###########################################
if [ `uname -m` = mips64el ]; then
	#initialize variable
	ROOT_DIR="/mnt/sysimage"
	ROOT_DEV=`df |grep /mnt/sysimage$ | awk -F " " '{print $1}'`   #  /dev/sda1
	ROOT_UUID=`blkid $ROOT_DEV | cut -d " " -f 2`
	#KERNEL_CMDLINE="rhgb quiet"
	#CDROM="/run/install/repo"
	df |grep "/run/install/repo$" > /dev/null
	if [ $? -eq 0 ];then
    	CDROM="/run/install/repo"
	else
		CDROM="/run/initramfs/live"
	fi

#	DEVICE=`echo $ROOT_DEV | cut -b1-8`   # ===> /dev/sda
	DEVICE=${ROOT_DEV%?}
	DEV=`echo $ROOT_DEV | awk -F '/' '{print $3}'`     # ===> sda1
	titledev=" ($DEV)" 		      # ===> (sda1)
	DEV_SDA1=""$DEVICE"1"

#	NUM=`echo $ROOT_DEV | cut -b9-11 | wc -L`

	#SDX_1="/dev/sda1"             #I want mount  $DEV_SDA1  on ($BOOT), but my Pmon read only /dev/sda1:/boot/*.cfg
	#SDX_1 Is Disk First Partition
	df |grep /mnt/sysimage/boot$ > /dev/null
	if [ $? -eq 0 ];then
		SDX_dev=`df |grep /mnt/sysimage/boot$ |awk '{print $1}'`
		SDX_1=${SDX_dev%?}1
	else
		echo $ROOT_DEV |grep "/dev/mapper" > /dev/null
		if [ $? -eq 0 ];then
			SDX_1=`fdisk  -l | grep "^/dev"| grep "*" | cut -d " " -f 1`
 		else
			SDX_1=$DEV_SDA1
		fi
	fi
	#SDX_1 Configure End

    BOOT="/mnt/stage1"		      #===>we need mount /dev/sda1 on it(BOOT)
    boot_on_sdx1=`df |grep /mnt/sysimage/boot$|cut -d " " -f 1`

    #add for btrfs post install
    #df |grep /mnt/sysimage$ |grep "btrfs" > /dev/null
    df -T |grep "btrfs" > /dev/null
    if [ $? -eq 0 ];then
        echo "btrfs install" >>/tmp/ws.log
        KERNEL_CMDLINE="rootflags=subvol=root rhgb quiet"
    else
        KERNEL_CMDLINE="rhgb quiet"
    fi
    #add end

    #add for lvm post install 
    df |grep /mnt/sysimage$ |grep "/dev/mapper" > /dev/null
    if [ $? -eq 0 ];then
        echo "lvm install" >> /tmp/ws.log
        DEV=`df |grep /mnt/sysimage$ | grep "/dev/mapper"|cut -d " " -f 1 |cut -c 13-`
        titledev=" ($DEV)"
    fi
    #add end

    #add by 9.22
    if [ -n "$boot_on_sdx1" ];then
	BOOT_SDA1="$BOOT"
    else
	BOOT_SDA1=""$BOOT"/boot"
    fi
    vmlinux="vmlinux"
    vmlinuz=`ls /mnt/sysimage/boot/ | grep vmlinuz|grep mips64el`
    vmlinuz_rescue=`ls /mnt/sysimage/boot/ | grep vmlinuz|grep rescue`
    initrd=`ls /mnt/sysimage/boot/ | grep initramfs |grep -v rescue |grep mips64el`
    initrd_rescue=`ls /mnt/sysimage/boot/ | grep initramfs |grep rescue`
    #add end

	#mount first partition
	mkdir -p $BOOT
	mount $SDX_1 $BOOT  # mount  /dev/sda1 /mnt/stage1

	#create /boot
	if [ -d $BOOT ];then
		echo "directory exist!"	>>/tmp/ws.log
	else
		mkdir -p $BOOT/     # /dev/sda1/boot
    fi


     cp $CDROM/boot/grub.efi $BOOT_SDA1/
     cp $CDROM/boot/grub64.efi $BOOT_SDA1/

	#delete the old(the same name) boot menu
	if [ -f $BOOT_SDA1/boot.conf ];then
        cat $BOOT_SDA1/boot.conf | grep "$titledev" >/dev/null
        if [ $? -eq 0 ];then
        	num1=`cat $BOOT_SDA1/boot.conf | grep -n "$titledev" |sed -n 1p| cut -d':' -f 1`
        	num2=`expr $num1 - 1`
        	num3=`expr $num1 + 8`
        	sed -i $num2','$num3'd' $BOOT_SDA1/boot.conf
        fi
	fi


	#generate grub.cfg. boot.cfg. boot.conf
	#for boot.conf
    if [ -f $BOOT_SDA1/boot.conf ];then
        sed -i "/showmenu 1/a\\\ntitle NeoKylin Linux Server 7.0$titledev\n\troot   (hd0,0)\n\tkernel /boot/$vmlinux root=$ROOT_UUID $KERNEL_CMDLINE\n\tinitrd /boot/$initrd\ntitle NeoKylin Linux Server <rescue-7.0 $titledev>\n\troot   (hd0,0)\n\tkernel /boot/$vmlinuz_rescue root=$ROOT_UUID $KERNEL_CMDLINE\n\tinitrd /boot/$initrd_rescue\n" $BOOT_SDA1/boot.conf
	else
		echo "
timeout 15
default 0
showmenu 1

title NeoKylin Linux Server 7.0$titledev
	root   (hd0,0)
	kernel /boot/$vmlinux  root=$ROOT_UUID $KERNEL_CMDLINE
    initrd /boot/$initrd
title NeoKylin Linux Server <rescue-7.0 $titledev>
	root   (hd0,0)
	kernel /boot/$vmlinuz_rescue  root=$ROOT_UUID $KERNEL_CMDLINE
    initrd /boot/$initrd_rescue
" > $BOOT_SDA1/boot.conf
	fi


#$    	fi
	cd /mnt/sysimage
	ln -s boot/efi/EFI EFI
        cd boot 
        NLINE=`grep $vmlinuz /mnt/sysimage/boot/efi/EFI/BOOT/grub.cfg  -rn |grep -v "rescue" |awk -F ":" '{print $1}'`
        NLINE1=`grep $initrd /mnt/sysimage/boot/boot.cfg  -rn |grep -v "rescue" |awk -F ":" '{print $1}'`
	NLINE2=`expr $NLINE1 + 1`
        SWAP_DEV=`fdisk -l |grep swap | awk -F " " '{print $1}'`
        if [ $? -eq 0 ];then
                sed -i "${NLINE}s:$: resume=$SWAP_DEV:" /mnt/sysimage/boot/efi/EFI/BOOT/grub.cfg
                sed -i "${NLINE2}s:$: resume=$SWAP_DEV:" /mnt/sysimage/boot/boot.cfg
        fi

#	cp -r efi/EFI /mnt/sysimage/EFI
        ln -s efi/EFI/ EFI
#	cp -r efi/EFI EFI
	cp -r efi/EFI/BOOT efi/
        ln -s efi/EFI/BOOT/grub.cfg grub.cfg
        ln -s . boot
        cd -

	umount $BOOT
	sync
fi

